/*
    QGL RendererMaterial
    Ivan Pelipenko peri4ko@yandex.ru

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef RENDERER_MATERIAL_H
#define RENDERER_MATERIAL_H

#include "glframebuffer.h"

#include <QQueue>


class QGLENGINE_CORE_EXPORT RendererMaterial {
	friend class QGLView;

public:
	RendererMaterial(Renderer * r_);
	virtual ~RendererMaterial();

	void init(int width, int height);
	void resize(int width, int height);

	QImage materialThumbnail(Material * m);
	void recreateMaterialThumbnails(bool force_all = false);
	void renderMaterial(Material * m);
	void procQueue();

private:
	Renderer * r;
	Framebuffer fbo_mat_thumb;
	Mesh * mat_sphere;
	Camera * mat_camera;
	Light * mat_light;
	QMap<Material *, QImage> mat_thumbnails;
	Material * last_thumb_material;
	QQueue<Material *> mat_thumb_queue;
};

#endif // RENDERER_MATERIAL_H
